package aspectEditor.aspectEditorUtils;
import java.util.jar.JarFile;
import java.util.*;
import java.io.*;
import edu.neu.ccs.demeter.aplib.*;
import edu.neu.ccs.demeter.*;
class GlobSet extends GlobSpec {
  protected Glob_Commalist globs;
  public Glob_Commalist get_globs() { return globs; }
  public void set_globs(Glob_Commalist new_globs) { globs = new_globs; }
  public GlobSet() { super(); }
  public GlobSet(Glob_Commalist globs) {
    super();
    set_globs(globs);
  }
  public static GlobSet parse(java.io.Reader in) throws ParseException { return new Parser(in)._GlobSet(); }
  public static GlobSet parse(java.io.InputStream in) throws ParseException { return new Parser(in)._GlobSet(); }
  public static GlobSet parse(String s) {
    try { return parse(new java.io.StringReader(s)); }
    catch (ParseException e) {
      throw new RuntimeException(e.toString());
    }
  }
  void addElement(Glob glob) {
    if (globs == null) globs = new Glob_Commalist();
    globs.addElement(glob);
  }
  public String toString() {
    return "{ " + (globs == null ? "" : globs.toString()) + " }";
  }
  void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before(this);
  }

  void universal_trv0_aft(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).after(this);
    super.universal_trv0_aft(_v_);
  }

  void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    if (globs != null) {
      ((UniversalVisitor) _v_).before_globs(this, globs);
      globs.universal_trv0(_v_);
      ((UniversalVisitor) _v_).after_globs(this, globs);
    }
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

  void __trav_checkConstraint_Node_SGEdge_trv_bef(__V_SGEdge_checkConstraint_Node __v0) {
    super.__trav_checkConstraint_Node_SGEdge_trv_bef(__v0);
  }

  void __trav_checkConstraint_Node_SGEdge_trv_aft(__V_SGEdge_checkConstraint_Node __v0) {
    super.__trav_checkConstraint_Node_SGEdge_trv_aft(__v0);
  }

  void __trav_checkConstraint_Node_SGEdge_trv(java.util.BitSet nodes, __V_SGEdge_checkConstraint_Node __v0) {
    __trav_checkConstraint_Node_SGEdge_trv_bef(__v0);
    { java.util.BitSet newnodes = new java.util.BitSet();
      newnodes.set(1);
      newnodes.and(nodes);
      if (!newnodes.equals(new java.util.BitSet())) {
        super.__trav_checkConstraint_Node_SGEdge_trv(newnodes, __v0);
      }
    }
    __trav_checkConstraint_Node_SGEdge_trv_aft(__v0);
  }

  void __trav_checkConstraint_Edge_SGEdge_trv_bef(__V_SGEdge_checkConstraint_Edge __v0) {
    super.__trav_checkConstraint_Edge_SGEdge_trv_bef(__v0);
  }

  void __trav_checkConstraint_Edge_SGEdge_trv_aft(__V_SGEdge_checkConstraint_Edge __v0) {
    super.__trav_checkConstraint_Edge_SGEdge_trv_aft(__v0);
  }

  void __trav_checkConstraint_Edge_SGEdge_trv(java.util.BitSet nodes, __V_SGEdge_checkConstraint_Edge __v0) {
    __trav_checkConstraint_Edge_SGEdge_trv_bef(__v0);
    { java.util.BitSet newnodes = new java.util.BitSet();
      newnodes.set(1);
      newnodes.and(nodes);
      if (!newnodes.equals(new java.util.BitSet())) {
        super.__trav_checkConstraint_Edge_SGEdge_trv(newnodes, __v0);
      }
    }
    __trav_checkConstraint_Edge_SGEdge_trv_aft(__v0);
  }

  void allGlobs_GlobSpec_trv_bef(GlobVisitor v) {
    super.allGlobs_GlobSpec_trv_bef(v);
    ((GlobVisitor) v).before(this);
  }

  void allGlobs_GlobSpec_trv_aft(GlobVisitor v) {
    ((UniversalVisitor) v).after(this);
    super.allGlobs_GlobSpec_trv_aft(v);
  }

  void allGlobs_GlobSpec_trv(GlobVisitor v) {
    allGlobs_GlobSpec_trv_bef(v);
    if (globs != null) {
      ((UniversalVisitor) v).before_globs(this, globs);
      globs.allGlobs_GlobSpec_trv(v);
      ((UniversalVisitor) v).after_globs(this, globs);
    }
    allGlobs_GlobSpec_trv_aft(v);
  }

  void __trav_matchEdge_GlobSpec_trv_bef(__V_GlobSpec_matchEdge __v0) {
    super.__trav_matchEdge_GlobSpec_trv_bef(__v0);
  }

  void __trav_matchEdge_GlobSpec_trv_aft(__V_GlobSpec_matchEdge __v0) {
    super.__trav_matchEdge_GlobSpec_trv_aft(__v0);
  }

  void __trav_matchEdge_GlobSpec_trv(__V_GlobSpec_matchEdge __v0) {
    __trav_matchEdge_GlobSpec_trv_bef(__v0);
    if (globs != null) {
      globs.__trav_matchEdge_GlobSpec_trv(__v0);
    }
    __trav_matchEdge_GlobSpec_trv_aft(__v0);
  }

  void __trav_match_GlobSpec_trv_bef(__V_GlobSpec_match __v0) {
    super.__trav_match_GlobSpec_trv_bef(__v0);
  }

  void __trav_match_GlobSpec_trv_aft(__V_GlobSpec_match __v0) {
    super.__trav_match_GlobSpec_trv_aft(__v0);
  }

  void __trav_match_GlobSpec_trv(java.util.BitSet nodes, __V_GlobSpec_match __v0) {
    __trav_match_GlobSpec_trv_bef(__v0);
    if (globs != null) {
      { java.util.BitSet newnodes = new java.util.BitSet();
        newnodes.set(0);
        newnodes.and(nodes);
        if (!newnodes.equals(new java.util.BitSet())) {
          globs.__trav_match_GlobSpec_trv(newnodes, __v0);
        }
      }
    }
    __trav_match_GlobSpec_trv_aft(__v0);
  }

  void __trav_collectClassGlobs_GlobSpec_trv_bef(__V_GlobSpec_collectClassGlobs __v0) {
    super.__trav_collectClassGlobs_GlobSpec_trv_bef(__v0);
  }

  void __trav_collectClassGlobs_GlobSpec_trv_aft(__V_GlobSpec_collectClassGlobs __v0) {
    super.__trav_collectClassGlobs_GlobSpec_trv_aft(__v0);
  }

  void __trav_collectClassGlobs_GlobSpec_trv(__V_GlobSpec_collectClassGlobs __v0) {
    __trav_collectClassGlobs_GlobSpec_trv_bef(__v0);
    if (globs != null) {
      globs.__trav_collectClassGlobs_GlobSpec_trv(__v0);
    }
    __trav_collectClassGlobs_GlobSpec_trv_aft(__v0);
  }

  void __trav_collectEdgeGlobs_GlobSpec_trv_bef(__V_GlobSpec_collectEdgeGlobs __v0) {
    super.__trav_collectEdgeGlobs_GlobSpec_trv_bef(__v0);
  }

  void __trav_collectEdgeGlobs_GlobSpec_trv_aft(__V_GlobSpec_collectEdgeGlobs __v0) {
    super.__trav_collectEdgeGlobs_GlobSpec_trv_aft(__v0);
  }

  void __trav_collectEdgeGlobs_GlobSpec_trv(__V_GlobSpec_collectEdgeGlobs __v0) {
    __trav_collectEdgeGlobs_GlobSpec_trv_bef(__v0);
    if (globs != null) {
      globs.__trav_collectEdgeGlobs_GlobSpec_trv(__v0);
    }
    __trav_collectEdgeGlobs_GlobSpec_trv_aft(__v0);
  }

}
